# =========================================================================== #
# Gemspec for Project HtmlTags.
# =========================================================================== #
require 'html_tags/version/version.rb'
require 'roebe/toplevel_methods/misc.rb'

Gem::Specification.new { |s|

  s.name    = 'html_tags'
  s.version = HtmlTags::VERSION
  s.date    = Time.now.strftime('%Y-%m-%d')

  DESCRIPTION = <<-EOF

    This library is called html_tags.

    Its basic core idea is to collect all valid html tags into
    a single project, and then make this data available to other
    projects.

    Other ideas are to autogenerate closing tags (helper
    methods), and of course to generate string representations
    of these html tags. This can then be used by other 
    web-projects.

    A simple usage example follows:

      require 'html_tags'
      HtmlTags.p 'hello world!' # => "<p>\nhello world!\n</p>"

    Since Version 0.0.10 (April 2014) we can also now query
    whether a string contains only valid HTML tags or whether
    it does not.

  EOF

  s.summary     = DESCRIPTION
  s.description = DESCRIPTION

  s.extra_rdoc_files = %w()

  s.authors   = ['Robert A. Heiler']
  s.email     = Roebe.email?
  s.files     = Dir['**/*']
  s.files    << 'USAGE.md'
  s.license   = 'MIT'
  s.homepage  = 'https://rubygems.org/gems/html_tags'

  s.required_ruby_version     = '>= '+Roebe.third_most_stable_version_of_ruby
  s.required_rubygems_version = '>= '+Gem::VERSION
  s.rubygems_version          = '>= '+Gem::VERSION

}