#!/usr/bin/ruby -w
# Encoding: UTF-8
# =========================================================================== #
require 'cliner/autoinclude' # Make the Cliner module known automatically.
require 'colours/autoinclude'
require 'beautiful_url'
require 'html_tags'
begin
  require 'colours'
rescue LoadError; end
N = "\n"
Cliner.set_colour 'lightblue'

# =========================================================================== #
# === _
#
# Simply colourize the input in a blue colour.
# =========================================================================== #
def _(i)
  if Object.const_defined? :Colours
    Colours.slateblue(i)
  else
    bold_blue(i)
  end
end

# =========================================================================== #
# === orange
# =========================================================================== #
def orange(i)
  Colours.orange(i.chomp)
end
cliner {
  e _('Testing some closing tags next (note that '+
    'we will keep trailing newlines:')
  e HtmlTags.close 'p'
  e HtmlTags.close 'div'
  e 'Finished testing closing tags.'
}; e
# =========================================================================== #
# Include the HtmlTags namespace next.
# =========================================================================== #
include HtmlTags
cliner { # Test <p> paragraph next.
  e _('Next testing some <p> paragraphs:')
  e p 'Hello World', :css_style => 'border: 1px solid red'
}


puts Colours.beautiful 'lightblue'
Cliner.set_colour 'lightblue'

# =========================================================================== #
# Next display all registered HTML tags:
# =========================================================================== #
e _('Registered Tags:')
registered_html_tags?
e p 'Good Bye', :css_class => 'border: 1px solid red',
                :id        => 'goodbye'
e; e

e 'Next, we test the String Good Bye, with a css class and an id.'
e p 'Good Bye', :css_class => 'border: 1px solid red',
                :id        => 'goodbye'
e
# =========================================================================== #
# Next, we will test the <a> tag.
# =========================================================================== #
cliner {
  e _('Next we will test the <a> tag in various combinations.')
  e orange(a('connect'))
  e orange(a('connect', :no_newline))
  e orange(a('connect', :make_newline))
  e orange(a('LINUX_DESIGNING.cgi', :copy_description))
  e orange(a('connect', 'marl1em','great_link','color: blue'))
  e orange(a('/test', :description => 'Link to test'))
  e orange(a('/test', css_style: 'margin-left:1em'))
}

e N+N+_('Next testing the <tbody> tag.')
e HtmlTags.tbody 'testing','this'
e N+N+_('Now testing the output of the BR tag:')
e HtmlTags::BR
e N+N+_('Next, we try to find out whether ch4() works:')
e ch4.lstrip
e N+N+_('Next, testing whether cbody() and chtml() works:')
e orange(cbody+chtml)
pp cbody+chtml
HtmlTags.strip_newlines
e cbody+chtml
pp cbody+chtml
e N+N+_('Next checking whether <hr> and <bb> are valid HTML tags:')
e is_valid_html? '<hr>'
e is_valid_html? '<bb>'
e N+N+_('Next testing the method stag() for capturing HTML tags as strings:')
e stag('span', 'padl1em')
cliner {
  e N+_('Next testing comments in .html files:')
  e HtmlTags.html_comment('This is a comment.')
}
e N+_('Next testing <span> with a hash as second argument:')+N+N
e span('wget', :css_style => 'margin-left:2em')
e orange(HtmlTags.stag('h3', :javascript => 'on-click: { this.color = "blue" }'))
e orange(HtmlTags.stag('h2', 'ud mart10px'))
cliner
e N+N+_('Next, we will test whether we can use button() combined with blocks:')+N+N
e orange(button('Click me!', 'pad1em', 'yo', '', :on_click => 'go back in history'))
e orange(HtmlTags.link 'http://google.com')
e orange(HtmlTags.link 'http://google.com', :desc => 'Google')
# x = HtmlTags.stag( :button, 'pad1em', 'yo', '', :on_click => 'go back in history') {{ :value => 'yo man' }}
e orange(stag 'h3', id: 'yo')
e orange(stag 'h3', id: 'yo', css_class: 'ok')
e orange(stag 'h3', id: 'yo', css_class: 'blue', css_style: 'margin:5em')
e orange(stag 'h3', id: 'yo', css_class: 'blue', css_style: 'margin:5em', content: 'yo there')
e orange(h3 'oki doki', id: 'hmm')
e 'We will next test the storage-functionality of HtmlTags:'
e 'First we clear the old entries.'
HtmlTags.clear
e
e 'Now we run three <h2> statements.'
h2 'Test'
h2 'Yo'
h2 'Hello world!'
e 'Next we show these:'
e orange(HtmlTags[])
e 'Now we clear it again. Then we run HtmlTags.clear'
HtmlTags.clear
e orange(HtmlTags.add 'hello', 'world!')
e orange(HtmlTags.add 'hello')
e 'Now we will check whether the 3 following HTML Tags are valid within a <head> element:'
e orange('p: ')+is_this_an_allowed_tag_in_head_element?('p').to_s
e orange('<div>: ')+is_this_an_allowed_tag_in_head_element?('<div>').to_s
e orange('<base>: ')+is_this_an_allowed_tag_in_head_element?('<base>').to_s
e
e "Next we will test: HtmlTags.a('google.com','Go to Google') {{ description: 'yo there' }}"
e
e '  '+orange(HtmlTags.a('google.com','s1em') {{ description: 'yo there' }}).delete(N)
e
cliner
e 'Next we will test '+orange('label()')+':'
e
e HtmlTags.label 'John Doe'
e
cliner
e h2('Showing the axe-icon next', 'marl1em','','',
     'on_click: show_image(:axe))') # Last one is javascript.
cliner
e 'Next testing:'
e "HtmlTags.a(BeautifulUrl[:my_gems], description: 'my gems')"
e HtmlTags.a(BeautifulUrl[:my_gems], description: 'my gems')
cliner
e 'HtmlTags.h2(text, css_class, the_id, css_style, javascript)'
e HtmlTags.h2('Hello world!','mars1em','','','onmouseover="this.style.textDecoration=\'underline\';"')
cliner
e 'Next testing the HtmlTags.img() tag:'
e "HtmlTags.img('foobar.png')"
e HtmlTags.img('foobar.png')
# ttags