#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'html_tags'
require 'colours/colours_e_autoinclude.rb'

@index = 0
# =========================================================================== #
# === esb
#
# This will also increment a counter automatically.
# =========================================================================== #
def esb(i)
  @index += 1
  e royalblue(@index.to_s+') ')+
    steelblue(i)
end

# =========================================================================== #
# === pad_yellow
# =========================================================================== #
def pad_yellow(i)
  e '  '+
    yellowgreen(i.to_s)
end

e
esb "Testing the HtmlTags.a() tag next - first via :content, "\
    "then also with \n:css_class in the second run:"
e
pad_yellow HtmlTags.a(
  'https://de.wikipedia.org/wiki/Lampensockel#Edisonsockel',
  content: 'SELF'
)
e
pad_yellow HtmlTags.a(
  [
    'https://de.wikipedia.org/wiki/Lampensockel#Edisonsockel',
    {content:'SELF', css_class:'mars2em'}
  ]
)
# =========================================================================== #
# === 2
# =========================================================================== #
e
esb 'Next testing the html tag <a> via the symbol :br meaning <br>:'
e
pad_yellow HtmlTags.a(
  'https://de.wikipedia.org/wiki/Lampensockel#Edisonsockel',
  'SELF',
  :make_newline
)
# =========================================================================== #
# === 3
# =========================================================================== #
e
esb 'Next testing it with a String as first argument, and a Hash '\
  'as the second argument:'
e
pad_yellow HtmlTags.a('https://geizhals.at/?cat=hhleuchtled&xf=1299_G9',
  content: 'G9 Sockel auf geizhals.at'
)
e

# =========================================================================== #
# === 4
# =========================================================================== #
e
esb 'Next testing css_style: as the second argument:'
e
pad_yellow HtmlTags.a(
  'https://rubygems.org/gems/ansi/',
  css_style: 'margin-left:1em'
)
e

# =========================================================================== #
# === 5
# =========================================================================== #
e
esb 'Next testing a Hash:'
e
pad_yellow HtmlTags.a(
  content: 'https://en.wikipedia.org/wiki/Bacteriochlorophyll',
  description: 'SELF'
)
e

# =========================================================================== #
# === 6
# =========================================================================== #
e
esb 'Next testing another Hash with :link_description:'
e
pad_yellow HtmlTags.a(
  'https://en.wikipedia.org/wiki/Bacteriochlorophyll',
  link_description: 'yo there',
  description: 'SELF'
)
e

# =========================================================================== #
# === 7
# =========================================================================== #
e
esb 'Next testing with →'
e
pad_yellow HtmlTags.a(
  '→ https://en.wikipedia.org/wiki/Bacteriochlorophyll',
  :self
)
e
